// Copyright (C) 2011 - INRIA - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

// A small demonstration of the Exponential distribution function.
// This function is not provided by Scilab.
// References
// Wikipedia, Exponential distribution function, http://en.wikipedia.org/wiki/Exponential_distribution

function p = exppdf ( x , lambda )
  p = lambda.*exp(-lambda.*x)
endfunction

function [p,q] = expcdf ( x , lambda )
  q = exp(-lambda.*x)
  p = 1-q
endfunction

function x = expinv ( p , lambda )
  // This is not accurate when p is small.
  x = - log(1-p)./lambda
endfunction

//
// Check the inversion
lambda=2;
x=3;
p = expcdf ( x , lambda ); // p = 0.9975212
x = expinv ( p , lambda ) // must be 3
//
// Load this script into the editor
//
filename = 'exponential.sce';
dname = get_absolute_file_path(filename);
editor ( dname + filename );

