
// Copyright (C) 2008-2009 - INRIA - Michael Baudin
// Copyright (C) 2009 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license
// http://www.gnu.org/copyleft/lesser.html

//
// gw_nisp.h
//   Header for the nisp gateway.
//
#ifndef __SCI_GW_NISP_H__
#define __SCI_GW_NISP_H__

extern "C" {

	// Functions providing interfaces to Scilab functions
	int sci_nisp_initseed (char *fname);
	int sci_nisp_startup (char *fname);
	int sci_nisp_shutdown (char *fname);
	int sci_nisp_verboselevelset (char *fname);
	int sci_nisp_verboselevelget (char *fname);
	int sci_randvar_tokens (char *fname);
	int sci_randvar_size (char *fname);
	int sci_randvar_new (char *fname);
	int sci_randvar_getvalue (char *fname);
	int sci_randvar_getlog (char *fname);
	int sci_randvar_destroy (char *fname);
	int sci_setrandvar_tokens (char *fname);
	int sci_setrandvar_size (char *fname);
	int sci_setrandvar_new (char *fname);
	int sci_setrandvar_freememory (char *fname);
	int sci_setrandvar_destroy (char *fname);
	int sci_setrandvar_addrandvar (char *fname);
	int sci_setrandvar_getlog (char *fname);
	int sci_setrandvar_getdimension (char *fname);
	int sci_setrandvar_getsize (char *fname);
	int sci_setrandvar_getsample (char *fname);
	int sci_setrandvar_setsample (char *fname);
	int sci_setrandvar_save (char *fname);
	int sci_setrandvar_buildsample (char *fname);
	int sci_polychaos_new (char *fname);
	int sci_polychaos_destroy (char *fname);
	int sci_polychaos_tokens (char *fname);
	int sci_polychaos_size (char *fname);
	int sci_polychaos_setdegree (char *fname);
	int sci_polychaos_getdegree (char *fname);
	int sci_polychaos_freememory (char *fname);
	int sci_polychaos_setdimoutput (char *fname);
	int sci_polychaos_getdimoutput (char *fname);
	int sci_polychaos_setsizetarget (char *fname);
	int sci_polychaos_getsizetarget (char *fname);
	int sci_polychaos_settarget (char *fname);
	int sci_polychaos_gettarget (char *fname);
	int sci_polychaos_freememtarget (char *fname);
	int sci_polychaos_getdiminput (char *fname);
	int sci_polychaos_getdimexp (char *fname);
	int sci_polychaos_getlog (char *fname);
	int sci_polychaos_computeexp (char *fname);
	int sci_polychaos_getmean (char *fname);
	int sci_polychaos_getvariance (char *fname);
	int sci_polychaos_getcovariance (char *fname);
	int sci_polychaos_getcorrelation (char *fname);
	int sci_polychaos_getindexfirst (char *fname);
	int sci_polychaos_getindextotal (char *fname);
	int sci_polychaos_getmultind (char *fname);
	int sci_polychaos_getgroupind (char *fname);
	int sci_polychaos_getgroupinter (char *fname);
	int sci_polychaos_getinvquantile (char *fname);
	int sci_polychaos_buildsample (char *fname);
	int sci_polychaos_getquantile (char *fname);
	int sci_polychaos_getquantwilks (char *fname);
	int sci_polychaos_getsample (char *fname);
	int sci_polychaos_setgroupempty (char *fname);
	int sci_polychaos_setgroupaddvar (char *fname);
	int sci_polychaos_computeexp (char *fname);
	int sci_polychaos_getanova (char *fname);
	int sci_polychaos_getanovaord (char *fname);
	int sci_polychaos_getanovaordco (char *fname);
	int sci_polychaos_realisation (char *fname);
	int sci_polychaos_save (char *fname);
	int sci_polychaos_generatecode (char *fname);
	int sci_polychaos_readtarget (char *fname);
	int sci_polychaos_compute (char *fname);

/* ==================================================================== */



}
#endif /* !__SCI_GW_NISP_H__ */
