
// Copyright (C) 2008-2009 - INRIA - Michael Baudin
// Copyright (C) 2009 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license
// http://www.gnu.org/copyleft/lesser.html

//
// nisp_support.hxx
//   Header for the C++ gateway support functions for NISP.
//
#ifndef __SCI_NISP_GWSUPPORT_H__
#define __SCI_NISP_GWSUPPORT_H__

#ifdef _MSC_VER
#pragma warning( disable : 4251 )
#endif

#include "nisp_va.h"
#include "nisp_gva.h"
#include "nisp_pc.h"

// TODO : rename these functions into nisp_Gw*
int nisp_AssertNumberOfRows ( char * fname , int ivar , int expected_nrows , int actual_nrows );
int nisp_AssertNumberOfColumns ( char * fname , int ivar , int expected_ncols , int actual_ncols );
int nisp_AssertVariableType ( char * fname , int ivar , int expected_type );
int nisp_GetTokenIndex ( char * fname , int ivar , int * token );
int nisp_token2RandomVariable( char * fname, int ivar , int token, RandomVariable ** rv);
int nisp_token2SetRandomVariable( char * fname, int ivar , int token, SetRandomVariable ** srv);
int nisp_token2PolynomialChaos( char * fname, int ivar , int token, PolynomialChaos ** pc);
int nisp_GetOneDoubleArgument ( char * fname , int ivar , double * value );
int nisp_GetOneIntegerArgument ( char * fname , int ivar , int * value );
int nisp_GetOneCharArgument ( char * fname , int ivar , char ** value );
int nisp_Double2IntegerArgument ( char * fname , int ivar , double dvalue , int * ivalue );
void nisp_CreateLhsInteger ( int ivar , int value );
void nisp_CreateLhsDouble ( int ivar , double value );

#define nisp_AssertNColumns(fname , ivar , expected_ncols , actual_ncols) \
	if ( nisp_AssertNumberOfColumns(fname , ivar , expected_ncols , actual_ncols) == 0 ) \
{ \
	return 0;\
}

#define nisp_AssertNRows(fname , ivar , expected_nrows , actual_nrows) \
	if ( nisp_AssertNumberOfRows(fname , ivar , expected_nrows , actual_nrows) == 0 ) \
{ \
	return 0;\
}

#define nisp_AssertVarType(fname , ivar , expected_type) \
	if ( nisp_AssertVariableType(fname , ivar , expected_type) == 0 ) \
{ \
	return 0;\
}

#define nisp_gettoken(fname , ivar , token ) \
	if ( nisp_GetTokenIndex(fname , ivar , token ) == 0 ) \
{ \
	return 0;\
}

#define nisp_token2Randvar(fname,ivar,token,rv) \
	if (nisp_token2RandomVariable(fname,ivar,token,rv)==0) { \
	return 0; \
	}

#define nisp_token2Setrandvar(fname,ivar,token,srv) \
	if (nisp_token2SetRandomVariable(fname,ivar,token,srv)==0) { \
	return 0; \
	}

#define nisp_token2Polychaos(fname,ivar,token,pc) \
	if (nisp_token2PolynomialChaos(fname,ivar,token,pc)==0) { \
	return 0; \
	}

#define nisp_GetOneDouble(fname,ivar,value) \
	if (nisp_GetOneDoubleArgument(fname,ivar,value)==0) { \
	return 0; \
	}

#define nisp_GetOneInteger(fname,ivar,value) \
	if (nisp_GetOneIntegerArgument(fname,ivar,value)==0) { \
	return 0; \
	}

#define nisp_GetOneChar(fname,ivar,value) \
	if (nisp_GetOneCharArgument(fname,ivar,value)==0) { \
	return 0; \
	}

#define nisp_Double2Integer(fname,ivar,dvalue,ivalue) \
	if (nisp_Double2IntegerArgument(fname,ivar,dvalue,ivalue)==0) { \
	return 0; \
	}

/* ==================================================================== */



#endif /* !__SCI_NISP_GWSUPPORT_H__ */