
// Copyright (C) 2008 - INRIA - Michael Baudin
// Copyright (C) 2009 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

extern "C" {
#include "stack-c.h" 
#include "Scierror.h"
#include "localization.h"
#include "gw_nisp.h"
}


/* ==================================================================== */

#include "nisp_gwsupport.hxx" 
#include "nisp_PolynomialChaos_map.hxx" 


/* ==================================================================== */
// 
// polychaos_buildsample ( token , type , np , order )
//   build an internal sampling of given type, with np simulations with order
// TODO : what is order ?
//
int sci_polychaos_buildsample (char *fname)
{
	int token;
	double *pdblFinalVar = NULL; //SCILAB return Var
	PolynomialChaos * pc = NULL;
	int np;
	char * type = NULL;
	int order;
	string stringtype;

	CheckRhs(4,4) ;
	CheckLhs(0,1) ;
	nisp_gettoken ( fname , 1 , &token );
	nisp_GetOneChar ( fname , 2 , &type );
	nisp_GetOneInteger ( fname , 3 , &np );
	nisp_GetOneInteger ( fname , 4 , &order );
	nisp_token2Polychaos ( fname , 1 , token , &pc );
	stringtype.assign(type);
	pc-> BuildSample ( stringtype , np , order );
	nisp_CreateLhsInteger ( 1 , token );
	return 0;
}
/* ==================================================================== */

