
// Copyright (C) 2008 - INRIA - Michael Baudin
// Copyright (C) 2009 - Digiteo - Michael Baudin
//
// This file must be used under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html

extern "C" {
#include "stack-c.h" 
#include "Scierror.h"
#include "localization.h"
#include "gw_nisp.h"
}


/* ==================================================================== */

#include "nisp_gwsupport.hxx" 
#include "nisp_PolynomialChaos_map.hxx" 


/* ==================================================================== */
// 
// np = polychaos_getsizetarget ( token )
//   returns the size of the target (i.e. the number of simulations) 
//
int sci_polychaos_getsizetarget (char *fname)
{
	int m, n;
	int token;
	double *pdblFinalVar = NULL; //SCILAB return Var
	PolynomialChaos * pc = NULL;
	double * mydata = NULL;
	int np;

	CheckRhs(1,1) ;
	CheckLhs(0,1) ;
	nisp_gettoken ( fname , 1 , & token );
	nisp_token2Polychaos ( fname , 1 , token , &pc );
	// Get size
	np = pc -> GetSizeTarget ( );
	// Returns the degree as the result
	m=1;
	n=1;
	iAllocMatrixOfDouble(Rhs+1, m, n, &pdblFinalVar);
	pdblFinalVar[0] = np;
	LhsVar(1) = Rhs+1;
	return 0;
}
/* ==================================================================== */

