//
// Copyright (C)  2006-2009 - CEA - Jean-Marc Martinez
// Copyright (C)  2009 - Digiteo - Michael Baudin
//
// This file is released under the terms of the GNU Lesser General Public License license :
// http://www.gnu.org/copyleft/lesser.html
//

#ifndef _NISP_POLYRULE_H_
#define _NISP_POLYRULE_H_

double r8_epsilon ( void );
double r8_gamma ( double x );
void hermite_recur ( double *p2, double *dp2, double *p1, double x, int order );
void hermite_root ( double *x, int order, double *dp2, double *p1 );
void hermite_compute ( int order, double xtab[], double weight[] );
void legendre_compute ( int order, double xtab[], double weight[] );
void laguerre_recur ( double *p2, double *dp2, double *p1, double x, 
  int order, double b[], double c[] );
void laguerre_root ( double *x, int order, double *dp2, double *p1, 
  double b[], double c[] );
void laguerre_compute ( int order, double xtab[], double weight[] );

#endif /* _NISP_POLYRULE_H_ */

